/// <reference types="bluebird" />
/// <reference types="sequelize" />
import * as Bluebird from 'bluebird';
import * as Sequelize from 'sequelize';
import { Query, InsertRequest, UpdateRequest, RemoveRequest } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { ModelDescriptor } from './descriptor';
import { ResultItemAppender } from './synchronizer';
export interface ModelDescriptorMap {
    [model: string]: ModelDescriptor<any>;
}
export interface Pool {
    models: ModelDescriptorMap;
    resolve<T>(query: Query<T>, context: any): Bluebird<ResolveResult<T>>;
    sync(transaction: Sequelize.Transaction, item: InsertRequest<any> | UpdateRequest<any> | RemoveRequest<any>, rip: ResultItemAppender, context: any): Bluebird<number | void>;
}
export declare function createPool(...descriptors: ModelDescriptor<any>[]): Pool;
