/// <reference types="bluebird" />
import * as Bluebird from 'bluebird';
import { Query } from 'pretur.sync';
import { Spec } from 'pretur.spec';
import { Pool } from './pool';
export interface ResolveResult<T> {
    data: T[];
    count?: number;
}
export interface Resolver<T> {
    (query: Query<T>, context: any): Bluebird<ResolveResult<T>>;
}
export interface CustomResolver<T> {
    (query: Query<T>, pool: Pool, context: any): Bluebird<ResolveResult<T>>;
}
export interface UnitializedResolver<T> {
    resolver: Resolver<T>;
    initialize(pool: Pool): void;
}
export interface ResolveInterceptor<T> {
    (query: Query<T>, result: ResolveResult<T>, context: any): Bluebird<ResolveResult<T>>;
}
export interface BuildResolverOptions<T> {
    intercept?: ResolveInterceptor<T>;
    queryTransformer?(query: Query<T>): Query<T>;
}
export declare function buildCustomResolver<T>(_: Spec<T>, resolver: CustomResolver<T>): UnitializedResolver<T>;
export declare function buildResolver<T>(spec: Spec<T>, options?: BuildResolverOptions<T>): UnitializedResolver<T>;
